if not (Klappa) then return; end;
local _G = getfenv(0);

local Klappa = Klappa;
local AceOO = AceLibrary("AceOO-2.0");

Klappa.Button = AceOO.Class("AceEvent-2.0");

function Klappa.Button.prototype:init(idx, type, id, bar)
	Klappa.Button.super.prototype.init(self);
	Klappa:Debug("Base class, index:");
	Klappa:Debug(idx);
	self.index = idx;
	self.type = type;
	self.id = id;
	self.bar = bar;
	self.barid = bar.index;
	self.isPopup = false;
	self.outOfRange = false;
	self.showgrid = 0;
	self.flashing = 0;
	self.flashtime = 0;
	self.elapsed = 0;
end

function Klappa.Button.prototype:ButtonProperties()
	local button = self.button;
	local name = button.name;
	
	--Create textures
	button.icon = _G[name .. "Icon"];
	button.icon:SetTexCoord(0.06, 0.94, 0.06, 0.94);
	
	button.normalTexture = _G[name .. "NormalTexture"];
	button.normalTexture:SetVertexColor(1, 1, 1, 0.5);
	
	button.pushedTexture = button:GetPushedTexture();
	button.highlightTexture = button:GetHighlightTexture();
	
	button.cooldown = _G[name.."Cooldown"];
	button.border = _G[name.."Border"];
	button.macroName = _G[name.."Name"];
	button.hotkey = _G[name.."HotKey"];
	button.count = _G[name.."Count"];
	button.flash = _G[name.."Flash"];
	button.flash:Hide();
	
	self:ApplyStyle();
	
	-- Register Buttons
	button:RegisterForDrag("LeftButton", "RightButton");
	button:RegisterForClicks("AnyUp");

	--Set scripts
	button:SetScript("OnDragStart", function() self:ButtonDrag(); end);
	button:SetScript("PostClick", function() self:UpdateState(); end);
	button:SetScript("OnEvent", function() self:OnEventFunc(event); end);
	button:SetScript("OnUpdate", function() self:OnUpdate(arg1); end);
	button:SetScript("OnReceiveDrag", function() self:ButtonDrop(); end );
	--self.button:SetScript("OnAttributeChanged", function() Klappa:OnAttributeChangedFunc(self.button);end);
	
	--Register general events
	self:RegisterGeneralEvents();
	
	--Set Attributes
	button:SetAttribute("type", "action");
	button:SetAttribute("checkselfcast", true);
	button:SetAttribute("useparent-unit", true);
	
	self:UpdateButton(true);
	--self:UpdateHotkeys();
end











